package com.upay.demo.declaration;


import com.alibaba.fastjson.JSONObject;
import com.upay.sdk.exception.HmacVerifyException;
import com.upay.sdk.exception.RequestException;
import com.upay.sdk.exception.ResponseException;
import com.upay.sdk.exception.UnknownException;
import com.upay.sdk.executer.ResultListenerAdpater;
import com.upay.sdk.serviceprovider.v3_0.declaration.builder.ElectronicReSignBuilder;
import com.upay.sdk.serviceprovider.v3_0.declaration.executer.ElectronicReSignExecuter;
import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ElectronicReSingServlet extends HttpServlet {

    private static final Logger LOGGER = LoggerFactory.getLogger(ElectronicReSingServlet.class);

    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        this.doPost(req, resp);
    }

    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        String merchantId = req.getParameter("merchantId");
        String subMerchantId = req.getParameter("subMerchantId");
        String requestId = req.getParameter("requestId");
        String eSignNotifyUrl = req.getParameter("eSignNotifyUrl");
        ElectronicReSignBuilder builder = new ElectronicReSignBuilder(merchantId);
        builder.setSubMerchantId(subMerchantId).setRequestId(requestId).seteSignNotifyUrl(eSignNotifyUrl);
        final PrintWriter out = resp.getWriter();
        ElectronicReSignExecuter executer = new ElectronicReSignExecuter();

        try {
            executer.reSign(builder, new ResultListenerAdpater() {
                public void success(JSONObject jsonObject) {
                    out.println("处理成功！<br/>");
                    String result = jsonObject.toJSONString();
                    out.print(result);
                }

                public void failure(JSONObject jsonObject) {
                    out.println("处理失败！<br/>");
                    String result = jsonObject.toJSONString();
                    out.print(result);
                }

                public void pending(JSONObject jsonObject) {
                    out.println("待处理！<br/>");
                    String result = jsonObject.toJSONString();
                    out.print(result);
                }
            });
        } catch (ResponseException var11) {
            out.println("响应异常</br>");
            out.println(var11.toString());
        } catch (HmacVerifyException var12) {
            out.println("签名验证异常</br>");
            out.println(var12.toString());
        } catch (RequestException var13) {
            out.println("请求异常</br>");
            out.println(var13.toString());
        } catch (UnknownException var14) {
            out.println("未知异常</br>");
            out.println(var14.toString());
        }

    }


}
