package com.upay.demo.declaration;

import com.alibaba.fastjson.JSONObject;
import com.upay.sdk.exception.HmacVerifyException;
import com.upay.sdk.exception.RequestException;
import com.upay.sdk.exception.ResponseException;
import com.upay.sdk.exception.UnknownException;
import com.upay.sdk.executer.ResultListenerAdpater;
import com.upay.sdk.serviceprovider.v3_0.declaration.builder.ModifyBaseInfoBuilder;
import com.upay.sdk.serviceprovider.v3_0.declaration.executer.ModifyBaseInfoExecuter;
import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * 修改商户信息接口
 */
public class ModifyBaseInfoServlet extends HttpServlet {

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        doPost(req, resp);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {

        String merchantId = req.getParameter("merchantId");
        String requestId = req.getParameter("requestId");
        String subMerchantId = req.getParameter("subMerchantId");
        String signedRequestId = req.getParameter("signedRequestId");
        String modifyType = req.getParameter("modifyType");
        String businessLicensePath = req.getParameter("businessLicensePath");
        String openAccountPath = req.getParameter("openAccountPath");
        String legalIdCardProsPath = req.getParameter("legalIdCardProsPath");
        String legalIdCardConsPath = req.getParameter("legalIdCardConsPath");
        String desireAuthPath = req.getParameter("desireAuthPath");
        String holdingIdCardPath = req.getParameter("holdingIdCardPath");
        String webSitePath = req.getParameter("webSitePath");
        String wechatAppletPath = req.getParameter("wechatAppletPath");
        String appPath = req.getParameter("appPath");
        String legalPersonBankCardPath = req.getParameter("legalPersonBankCardPath");
        String desireAuthOtherPath = req.getParameter("desireAuthOtherPath");
        String otherCerPath = req.getParameter("otherCerPath");
        String storeHeaderPath = req.getParameter("storeHeaderPath");
        String storeIndoorPath = req.getParameter("storeIndoorPath");

        ModifyBaseInfoBuilder builder = new ModifyBaseInfoBuilder(merchantId);
        builder.setRequestId(requestId);
        builder.setSubMerchantId(subMerchantId);
        builder.setSignedRequestId(signedRequestId);
        builder.setModifyType(modifyType);
        builder.setBusinessLicensePath(businessLicensePath);
        builder.setOpenAccountPath(openAccountPath);
        builder.setLegalIdCardProsPath(legalIdCardProsPath);
        builder.setLegalIdCardConsPath(legalIdCardConsPath);
        builder.setDesireAuthPath(desireAuthPath);
        builder.setHoldingIdCardPath(holdingIdCardPath);
        builder.setWebSitePath(webSitePath);
        builder.setWechatAppletPath(wechatAppletPath);
        builder.setAppPath(appPath);
        builder.setLegalPersonBankCardPath(legalPersonBankCardPath);
        builder.setDesireAuthOtherPath(desireAuthOtherPath);
        builder.setOtherCerPath(otherCerPath);
        builder.setStoreHeaderPath(storeHeaderPath);
        builder.setStoreIndoorPath(storeIndoorPath);

        final PrintWriter out = resp.getWriter();

        ModifyBaseInfoExecuter executer = new ModifyBaseInfoExecuter();

        try {

            executer.modify(builder, new ResultListenerAdpater() {
                @Override
                public void success(JSONObject jsonObject) {
                    out.println("处理成功！<br/>");
                    String result = jsonObject.toJSONString();
                    out.print(result);
                }

                @Override
                public void failure(JSONObject jsonObject) {
                    out.println("处理失败！<br/>");
                    String result = jsonObject.toJSONString();
                    out.print(result);
                }

                @Override
                public void pending(JSONObject jsonObject) {
                    out.println("待处理！<br/>");
                    String result = jsonObject.toJSONString();
                    out.print(result);
                }
            });
        } catch (ResponseException e) {
            out.println("响应异常</br>");
            out.println(e.toString());
        } catch (HmacVerifyException e) {
            out.println("签名验证异常</br>");
            out.println(e.toString());
        } catch (RequestException e) {
            out.println("请求异常</br>");
            out.println(e.toString());
        } catch (UnknownException e) {
            out.println("未知异常</br>");
            out.println(e.toString());
        }
    }
}
