package com.upay.demo.sample;

import com.alibaba.fastjson.JSONObject;
import com.upay.demo.utils.JsonBuilder;
import com.upay.demo.utils.MyExecuter;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ApiRequestDemo {
    static final Logger LOGGER = LoggerFactory.getLogger(ApiRequestDemo.class);

    static public void declarationQuery() {
        String merchantId = "890000593";
        String partnerId = null;

        String apiUrl = "https://apis.5upay.com/serviceprovider/declaration/query";
        String rawJsonData = "{\"merchantId\": \"890000593\",\"subMerchantId\": \"894120754\"}";

        JSONObject rawDataJson = JSONObject.parseObject(rawJsonData);

        LOGGER.info("接口地址：{}", apiUrl);
        LOGGER.info("请求报文json: {}: ", rawDataJson.toJSONString());

        JsonBuilder jsonSupport = new JsonBuilder(merchantId, partnerId, rawDataJson);
        MyExecuter myExecuter = new MyExecuter();
        JSONObject rawRespJsonData = myExecuter.ApiRequest(jsonSupport, apiUrl);

        LOGGER.info("应答报文json: {}: ", rawRespJsonData.toJSONString());
    }


    static public void main(String[] args) {

        ApiRequestDemo.declarationQuery();


    }
}
